package org.jboss.security.auth.callback;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import javax.security.auth.callback.Callback;
import javax.security.auth.callback.CallbackHandler;
import javax.security.auth.callback.NameCallback;
import javax.security.auth.callback.PasswordCallback;
import javax.security.auth.callback.UnsupportedCallbackException;
import org.jboss.security.auth.callback.ObjectCallback;

public class UsernamePasswordHandler implements CallbackHandler {
  private transient String username;
  
  private transient char[] password;
  
  private transient Object credential;
  
  public UsernamePasswordHandler(String username, char[] password) {
    this.username = username;
    this.password = password;
    this.credential = password;
  }
  
  public UsernamePasswordHandler(String username, Object credential) {
    this.username = username;
    this.credential = credential;
  }
  
  public void handle(Callback[] callbacks) throws UnsupportedCallbackException {
    for (int i = 0; i < callbacks.length; i++) {
      Callback c = callbacks[i];
      if (c instanceof NameCallback) {
        NameCallback nc = (NameCallback)c;
        nc.setName(this.username);
      } else if (c instanceof PasswordCallback) {
        PasswordCallback pc = (PasswordCallback)c;
        if (this.password == null)
          if (this.credential != null) {
            String tmp = this.credential.toString();
            this.password = tmp.toCharArray();
          }  
        pc.setPassword(this.password);
      } else if (c instanceof ObjectCallback) {
        ObjectCallback oc = (ObjectCallback)c;
        oc.setCredential(this.credential);
      } else {
        throw new UnsupportedCallbackException(callbacks[i], "Unrecognized Callback");
      } 
    } 
  }
}
